#[doc = "Register `A06` reader"]
pub struct R(crate::R<A06_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<A06_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<A06_SPEC>> for R {
    fn from(reader: crate::R<A06_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `A06` writer"]
pub struct W(crate::W<A06_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<A06_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<A06_SPEC>> for W {
    fn from(writer: crate::W<A06_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `A0_LS` reader - Accumulator 0 for UDB\\[n\\]"]
pub struct A0_LS_R(crate::FieldReader<u8, u8>);
impl A0_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_LS` writer - Accumulator 0 for UDB\\[n\\]"]
pub struct A0_LS_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_LS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u16 & 0xff);
        self.w
    }
}
#[doc = "Field `A0_MS` reader - Accumulator 0 for UDB\\[n+1\\]"]
pub struct A0_MS_R(crate::FieldReader<u8, u8>);
impl A0_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0_MS` writer - Accumulator 0 for UDB\\[n+1\\]"]
pub struct A0_MS_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_MS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u16 & 0xff) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Accumulator 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn a0_ls(&self) -> A0_LS_R {
        A0_LS_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Accumulator 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn a0_ms(&self) -> A0_MS_R {
        A0_MS_R::new(((self.bits >> 8) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Accumulator 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn a0_ls(&mut self) -> A0_LS_W {
        A0_LS_W { w: self }
    }
    #[doc = "Bits 8:15 - Accumulator 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn a0_ms(&mut self) -> A0_MS_W {
        A0_MS_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Accumulator 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [a06](index.html) module"]
pub struct A06_SPEC;
impl crate::RegisterSpec for A06_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [a06::R](R) reader structure"]
impl crate::Readable for A06_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [a06::W](W) writer structure"]
impl crate::Writable for A06_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets A06 to value 0"]
impl crate::Resettable for A06_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
